2017-04-28 09:32:35 -04:00
#!/bin/bash
# Build and run flatpak's unit tests using the just-built ostree for this PR.
set -xeuo pipefail
2018-06-29 13:53:54 -04:00
# Keep this pinned to avoid arbitrary change for now; it's also
# good to test building older code against newer ostree as it helps
# us notice any API breaks.
2019-06-19 18:22:11 -04:00
FLATPAK_TAG = 1.4.1
2018-01-09 13:01:47 -05:00
2017-09-06 12:42:51 -04:00
dn = $( dirname $0 )
2020-06-17 15:48:31 -04:00
. ${ dn } /libbuild.sh
2017-09-06 12:42:51 -04:00
2017-04-28 09:32:35 -04:00
codedir = $( pwd )
2018-06-29 13:53:54 -04:00
# Build ostree, but we don't install it yet
2017-05-01 18:02:27 -04:00
cd ${ codedir }
2018-05-29 19:09:07 -07:00
ci/build.sh
# Build flatpak
2018-01-09 13:01:47 -05:00
tmpd = $( mktemp -d)
cd ${ tmpd }
git clone --recursive --depth= 1 -b ${ FLATPAK_TAG } https://github.com/flatpak/flatpak
2017-05-01 18:02:27 -04:00
cd ${ tmpd } /flatpak
2020-01-21 15:47:01 -07:00
# Some of flatpak's tests assert GPG error strings from ostree, but
# those have been changed. Patch the test assertions until this can get
# into a tagged flatpak.
git apply ${ codedir } /ci/flatpak-1.4.1-ostree-gpg-errors.patch
2018-06-29 13:53:54 -04:00
# This is a copy of flatpak/ci/build.sh, but we can't use that as we want to install
# our built ostree over it.
pkg_install sudo which attr fuse bison \
libubsan libasan libtsan clang python2 \
elfutils git gettext-devel libappstream-glib-devel hicolor-icon-theme \
/usr/bin/{ update-mime-database,update-desktop-database,gtk-update-icon-cache}
pkg_builddep flatpak
# Now install ostree over the package version
cd ${ codedir }
make install
cd -
# And build flatpak
build
2017-04-28 09:32:35 -04:00
# We want to capture automake results from flatpak
cleanup( ) {
mv test-suite.log ${ codedir } || true
}
trap cleanup EXIT
make -j 8 check